/* rawfunc.c   by Michael Thorpe   2005-07-12 */

#include <stdio.h>
#include "lisp.h"

static obj *applyrawfunc(scope *s,obj *func,obj *args) {
	int i,numargs;
	obj *p;
	obj *arg[4];
	union rawfuncptr rfp;

	for(i=0,p=args;i<4 && p->type==&cons_objtype;p=p->value.c.d)
		arg[i++]=p->value.c.a;
	numargs=i;
	if(p->type==&cons_objtype || numargs != func->value.rawfunc.numargs) {
		decscoperef(s);
		p=newobj(&cons_objtype);
		if(!p) {
			decref(func);
			decref(args);
			return(0);
		}
		p->value.c.a=func;
		p->value.c.d=args;
		return(throwargumenterror(p));
	}
	for(i=0;i<numargs;i++)
		arg[i]=incref(arg[i]);
	decref(args);
	rfp=func->value.rawfunc.rawfuncptr;
	if(!func->value.rawfunc.wantscope)
		decscoperef(s);
	i=(func->value.rawfunc.numargs<<1)|func->value.rawfunc.wantscope;
	decref(func);
	switch(i) {
	case (0<<1)|0:
		return((rfp.ns0)());
	case (0<<1)|1:
		return((rfp.s0)(s));
	case (1<<1)|0:
		return((rfp.ns1)(arg[0]));
	case (1<<1)|1:
		return((rfp.s1)(s,arg[0]));
	case (2<<1)|0:
		return((rfp.ns2)(arg[0],arg[1]));
	case (2<<1)|1:
		return((rfp.s2)(s,arg[0],arg[1]));
	case (3<<1)|0:
		return((rfp.ns3)(arg[0],arg[1],arg[2]));
	case (3<<1)|1:
		return((rfp.s3)(s,arg[0],arg[1],arg[2]));
	}
	return(0);
}

static obj *rawfunc_tostring(obj *in) {
	obj *out;
	char buf[27];
	int i;

	i=snprintf(buf,sizeof(buf),"rawfunc-%p",in->value.rawfunc.rawfuncptr.ns0);
	if(i==-1 || i>sizeof(buf))
		return(throwrangecheck(in));
	decref(in);
	out=newstring(buf,i);
	return(out);
}

objtype rawfunc_objtype={
	name: "rawfunc",
	tostring: rawfunc_tostring,
	applyfunc: applyrawfunc
};

